package org.amse.mARICa.model.impl;

import java.util.ArrayList;

import org.amse.mARICa.Logger;
import org.amse.mARICa.model.ESeatPlayer;
import org.amse.mARICa.model.IBoard;

public class Board implements IBoard, Cloneable {
	/**
	 *     
	 */
	private int myCountPots;

	/**
	 *      ( myCountPots + 1 ) * 2 
	 *  
	 */
	private int myCountAllPots;

	/**
	 *      
	 */
	private int myCountBeans;

	/**
	 *   
	 */
	private int[] myPots;

	/**
	 *   " "   
	 */
	private int myKalah1;

	private int myKalah2;

	/**
	 *   ,     
	 *  choose()
	 */
	private ArrayList<Move> myMoves;

	private boolean myIsFinishGame;

	/**
	 *     countPots      
	 * countBeans     " " 
	 *     
	 * 
	 * @param countPots -
	 *            -     
	 * @param countBeans -
	 *            -   
	 */
	public Board(int countPots, int countBeans) {
		myCountPots = countPots;
		myCountAllPots = (myCountPots + 1) * 2;
		myCountBeans = countBeans;
		myPots = new int[myCountAllPots];
		for (int i = 0; i < myPots.length; i++) {
			myPots[i] = countBeans;
		}
		myKalah1 = countPots;
		myKalah2 = myPots.length - 1;
		myPots[myKalah1] = 0;
		myPots[myKalah2] = 0;
		//myListeners = new ArrayList<IModelListener>();
	}

	public int[] getState() {
		//    
		int[] pots = new int[myPots.length];
		for (int i = 0; i < myPots.length; i++) {
			pots[i] = myPots[i];
		}
		return pots;
	}

	public int getCountInPot(int k) {
		if (k < 0 || k >= myPots.length) {
			return -1;
		}
		return myPots[k];
	}

	public int getCountPots() {
		return myCountPots;
	}

	public int getCountAllPots() {
		return myCountAllPots;
	}

	public int getCountBeans() {
		return myCountBeans;
	}
	
	public void setCountBeans(int countBeans) {
		myCountBeans = countBeans;
		for (int i = 0; i < myPots.length; i++) {
			myPots[i] = countBeans;
		}
		myPots[myKalah1] = 0;
		myPots[myKalah2] = 0;
	}
	/**
	 *   -      
	 * @param countBeans - ,   
	 */
	public void setCountBeans(int countBeans []) {
		for (int i = 0; i < myPots.length; i++) {
			myPots[i] = countBeans[i];
		}
	}

	public int getCountInKalah1() {
		return myPots[myKalah1];
	}

	public int getCountInKalah2() {
		return myPots[myKalah2];
	}

	public boolean canChoose(ESeatPlayer player, int k) {
		if (player == ESeatPlayer.DOWN) {
			return k >= 0 && k < myCountPots && myPots[k] != 0;
		}
		return k >= 0 && k < myCountPots && myPots[k + 1 + myCountPots] != 0;
	}

	/**
	 *       
	 * 
	 * @return
	 */
	private int sumBeansUpPleayer() {
		int sum = 0;
		for (int i = myKalah1 + 1; i < myKalah2; i++) {
			sum += myPots[i];
		}
		return sum;
	}

	/**
	 *       
	 * 
	 * @return
	 */
	private int sumBeansDownPleayer() {
		int sum = 0;
		for (int i = 0; i < myKalah1; i++) {
			sum += myPots[i];
		}
		return sum;
	}

	/**
	 *       ,    
	 *    
	 */
	private void endBeansOfPlayer() {
		if (sumBeansUpPleayer() == 0) {
			myIsFinishGame = true;
			for (int i = 0; i < myKalah1; i++) {
				myPots[myKalah1] += myPots[i];
				myPots[i] = 0;
			}
		} else if (sumBeansDownPleayer() == 0) {
			myIsFinishGame = true;
			for (int i = myKalah1 + 1; i < myKalah2; i++) {
				myPots[myKalah2] += myPots[i];
				myPots[i] = 0;
			}
		}
	}

	public boolean choose(ESeatPlayer player, int num) {
		if (!canChoose(player, num)) {
			return false;
		}
		//  num     0..13
		if (player == ESeatPlayer.UP) {
			num = num + 1 + myCountPots;
		}
		myMoves = new ArrayList<Move>();
		num = movesBeans(player, num);
		//       ,  ,
		//     
		if (num == myKalah1 || num == myKalah2) {
			endBeansOfPlayer();
			return true;
		}
		//  
		if (player == ESeatPlayer.DOWN) {
			if (num >= 0 && num <= myKalah1 && myPots[num] == 1) {
				captureBeans(player, myKalah1, num);
			}	
		}else{// player == ESeatPlayer.UP
			if (num >= myKalah1 + 1 && num <= myKalah2 && myPots[num] == 1) {
				captureBeans(player, myKalah2, num);
			}
		}	
		endBeansOfPlayer();
		return false;
	}

	private int movesBeans(ESeatPlayer player, int num) {
		myMoves.add(new Move(num, 0, true));
		int countBeans = myPots[num];
		myPots[num] = 0;
		for (int i = countBeans; i > 0; i--) {
			//  c 
			num = getNextPot(player, num);
			myPots[num] += 1;
			//    
			myMoves.add(new Move(num, myPots[num]));			
		}
		return num;
	}

	private void captureBeans(ESeatPlayer player, int kalah, int num) {
		//     num
		myPots[kalah] += myPots[num];
		myPots[num] = 0;
		myMoves.add(new Move(num, myPots[num], true));
		myMoves.add(new Move(kalah,myPots[kalah]));	
		int oppositePot = opposite(player, num);
		//     oppositePot
		boolean isMove = false;
		if (myPots[oppositePot] != 0){
			isMove = true;
		}
		myPots[kalah] += myPots[oppositePot];
		myPots[oppositePot] = 0;
		if (isMove){
			myMoves.add(new Move(oppositePot, myPots[oppositePot], true));
			myMoves.add(new Move(kalah, myPots[kalah]));
		}
	}

	/**
	 *     
	 *     13 12 11 10 9 8 
	 * 14 - | |  |  |  | | -7 
	 *      1 2  3  4  5 6
	 * 
	 * @param n -   
	 * @return  
	 */
	private int opposite(ESeatPlayer player, int n) {
		int kalah;//    ,    1
		if (player == ESeatPlayer.DOWN) {
			kalah = myKalah1 + 1;
		} else {
			kalah = myKalah2 + 1;
		}
		//    1..N
		if (n++ != kalah) {
			return (kalah + kalah - n) % myCountAllPots - 1;
		}
		if (kalah == myKalah1) {
			return myKalah2;
		}// kalah == myBoard.getKalahOfPlayer2()
		return myKalah1;

	}

	/**
	 *    ,    
	 * 
	 * 
	 * @param n -
	 *              
	 * @return   
	 */
	private int getNextPot(ESeatPlayer player, int n) {
		int nI = (n + 1) % getCountAllPots();
		//   
		if ((player == ESeatPlayer.DOWN) && (nI == myKalah2)) {
			nI = ++nI % myCountAllPots;
		}

		if ((player == ESeatPlayer.UP) && (nI == myKalah1)) {
			nI = ++nI % myCountAllPots;
		}
		return nI;
	}

	private void setArrayPot(int[] pots) {
		myPots = pots;
	}

	public Object clone() {
		Object obj = null;
		try {
			obj = super.clone();
			((Board) obj).setArrayPot(this.cloneArrayPots());
		} catch (CloneNotSupportedException e) {
			e.printStackTrace();
		}
		return (obj);
	}

	private int[] cloneArrayPots() {
		int[] pots = new int[myPots.length];
		for (int i = 0; i < pots.length; i++) {
			pots[i] = myPots[i];
		}
		return pots;
	}

	public void logBoard() {
		Logger log = Logger.getInctanse();
		log.print("Board: ");
		for (int i = 0; i < myPots.length; i++) {
			log.print(myPots[i] + " ");
		}
		log.println("");
	}

	public ArrayList<Move> getMoves() {
		return myMoves;
	}

	public boolean isFinishGame() {
		return myIsFinishGame;
	}
}
