package org.amse.mARICa.model.impl.players;

import org.amse.mARICa.Logger;
import org.amse.mARICa.game.IGame;
import org.amse.mARICa.model.EKindPlayer;
import org.amse.mARICa.model.IBoard;

public class AIAlphaBetaPlayer extends AIPlayer {

	private int myBetaCutoff;
	private int myAlphaCutoff;	
	
	public AIAlphaBetaPlayer(EKindPlayer kind, IGame game) {
		super(kind, game);		
	}

	public AIAlphaBetaPlayer(EKindPlayer kind, IGame game, int maxLevel,
			boolean rand) {
		super(kind, game, maxLevel, rand);
	}
	
	protected  void findOptimumPot(){
		myCopyBoard = (IBoard)myGame.getBoard().clone();
		myLevelZeroAgain = 0;
		myCountTreeNodes = 0;
		myAlphaCutoff = 0;
		myBetaCutoff = 0;
		int parentEval = initDynCritFunc(0);
		findInRecursy(-1, myCopyBoard, 0, parentEval, false);
		Logger.getInctanse().println("\nmyAlphaCutoff=" + myAlphaCutoff);
		Logger.getInctanse().println("myBetaCutoff=" + myBetaCutoff);
	}
	
	protected int calcDynCritFunc(int level, int s, int eval, int ipot) {
		if (level % 2 != 0){
			eval = Math.min(s, eval);
		}else{
			eval  = Math.max(s, eval);
			if(level == 0 && myLevelZeroAgain == 0){
				if (s == myBranchChoose.get(0)){
					myBranchChoose.add(ipot);
				}else if(myBranchChoose.get(0) < s){
					myBranchChoose.clear();
					myBranchChoose.add(0, eval);
					myBranchChoose.add(ipot);
					eval = myBranchChoose.get(0);
				}									
			}
		}
		return eval;
	}
	
	protected int findInRecursy(int pot, IBoard board, int level, int parentEval, boolean levelAgain){
		Logger log = Logger.getInctanse();
		if (myStopGame){
			return -100;
		}
		if (pot >= 0){
			boolean isAgainMove = choose(board, level, pot);
			myCountTreeNodes++;			
			if (myIsLogTreeNodes){
				if (level % 2 == 0){
					log.AIprintln("\n" + myHisSeat + " player choose " + pot + " pot on level=" + ( level - 1) + " parentEval=" + parentEval + "  myCountTreeNodes=" + myCountTreeNodes);
				}else{
					   log.AIprintln("\n" + mySeat + " player choose " + pot + " pot on level=" + ( level - 1) + " parentEval=" + parentEval + "  myCountTreeNodes=" + myCountTreeNodes);
				}
				board.logBoard();				
			}
			if (isAgainMove){
				if (level == 1){
					//           myBranchChoose
					myLevelZeroAgain++;
					int eval = findInRecursy(-1, board, level-1, parentEval, true);
					myLevelZeroAgain--;
					return eval;
				}
				return findInRecursy(-1, board, level-1, parentEval, true);
			}
		}
		int s;
		int eval = 0;
		if (level == myMaxLevel || board.isFinishGame()) {
			s = calcStatCritFunc(board);
			log.AIprintln("Stat = " + s + "  FinishGame=" + board.isFinishGame());
			return s;
		}else{
			eval = initDynCritFunc(level);
			/*if (level % 2 != 0){
				alpha = Integer.MIN_VALUE;
			}else{
				beta = Integer.MAX_VALUE;
			}*/
			for(int ipot = 0; ipot < myCopyBoard.getCountPots(); ipot++){
				if (myStopGame){
					return -100;
				}
				if (canChoose(board, level, ipot)){
					s = findInRecursy(ipot, (IBoard)board.clone(), level+1, eval, false);					
					log.AIprint("eval=" + eval + " s=" + s);
					eval = calcDynCritFunc(level, s, eval, ipot);
					log.AIprintln(" => eval=" + eval);
					if (levelAgain){
						level++;// CUTOFF      if'
					}
					if (level % 2 != 0 && s < parentEval){
						if (levelAgain){ 
							log.AIprintln("YZ");
						}
						myAlphaCutoff++; 
						log.AIprintln("ALPHA CUTOFF  alpha=" + parentEval + " ipot=" + ipot + "  level=" + level);
						return eval; 
					}
					if (level % 2 == 0  && level != 0 && s > parentEval ){
						if (levelAgain){ 
							log.AIprintln("YZ");
						}
						myBetaCutoff++;
						log.AIprintln("BETA CUTOFF  beta=" + parentEval + " ipot=" + ipot + "  level=" + level);
						return eval;
					}
					if (levelAgain){
						level--;
					}
				}
			}
		}
		return eval;
	}

	public int getAlphaCutoff() {
		return myAlphaCutoff;
	}

	public int getBetaCutoff() {
		return myBetaCutoff;
	}

}
