package org.amse.mARICa.view;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import org.amse.mARICa.Logger;
import org.amse.mARICa.Main;
import org.amse.mARICa.game.AbstractGameListener;
import org.amse.mARICa.game.IGame;
import org.amse.mARICa.game.IGameListener;
import org.amse.mARICa.model.*;
import org.amse.mARICa.model.impl.players.LocalPlayer;
/**
 *    -  
 *  .    
 *   - ,    .
 *   - 
 *       2  
 *    (   ).
 * @author mARICa
 *
 */
public class BoardPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	
	ButtonPanel buttonPanel;
	
	private int myCountPlayers = 0;
	private IGame myGame;
	private PotLabel [] myPotLabels;
	//private LocalPlayer myCurrentPlayer;	
	private LocalPlayer [] myLocalPlayers = new LocalPlayer [2];//  
	boolean myIsGameNow;//  ButtonsPanel
	private HandLabel myHand;
	private int myHeightPot = 50;
	private int myWidthPot = 40;
	private boolean myStopGame;
	
	/*private class DataOfPlayer{
		boolean myCurrentPlayer;//     ( MouseListener)
		int myChoosingPot;
		boolean myIsReady;
		ESeatPlayer mySeat;
		EKindPlayer myKind;
	}*/

	/**
	 *   .
	 * @param countAllPots - -  
	 * @param iconPotHeight -   
	 * @param iconPotWidth -   
	 */
	public BoardPanel(int countAllPots, int iconPotWidth, int iconPotHeight){
		super();
		myIsGameNow = false;
		myStopGame = false;
		myWidthPot = iconPotWidth;
		myHeightPot = iconPotHeight;
		createPotLabels(countAllPots);
		setSize(320, 125);
		myHand = new HandLabel(new ModelListener(), myPotLabels);
		this.add(myHand);
		//this.addKeyListener(new MyKeyListener());
	}
	
	public void beforeStartGame(){
		myCountPlayers = 0;
		myStopGame = false;
	}
	
	public HandLabel getHand(){
		return myHand;
	}

	/*public void changePlayers(){
		if (myCountPlayers != 2){
			return;
		}
		if (myCurrentPlayer == myLocalPlayers[0]){
			myLocalPlayers[0].setCurrent(false);
			myCurrentPlayer = myLocalPlayers[1];
			myLocalPlayers[1].setCurrent(true);
		}else{
			myLocalPlayers[1].setCurrent(false);
			myCurrentPlayer = myLocalPlayers[0];
			myLocalPlayers[0].setCurrent(true);
		}		
	}	*/
	
	public IPlayer createLocalPlayer(EKindPlayer kind){
		if (myCountPlayers >= 2){
			return null;
		}
		myLocalPlayers[myCountPlayers] = new LocalPlayer(kind, myGame);
		//  ( ,   this)     [0]
		//myCurrentPlayer = myLocalPlayers[0];		
		return myLocalPlayers[myCountPlayers++];
	}

	private void createPotLabels(int countAllPots){
		this.setBorder(BorderFactory.createRaisedBevelBorder());
		
		MouseListener ml = new MouseListener();
		myPotLabels = new PotLabel [countAllPots];
		int countPots = (countAllPots - 2) / 2;
		int startPotDown = 0;
		int endPotDown = countPots - 1;
		int kalahDown = endPotDown + 1;
		int startPotUp = endPotDown + 2;
		int endPotUp = countAllPots - 2;
		int kalahUp = endPotUp + 1;
		
		//  
		JPanel upPan = new JPanel();
		upPan.setLayout(new BoxLayout(upPan, BoxLayout.X_AXIS));
		for (int i = endPotUp; i >= startPotUp; i--){
			myPotLabels[i] =  new PotLabel(i-7, ESeatPlayer.UP, 0);
			upPan.add(myPotLabels[i]);
		}
		//  
		JPanel downPan = new JPanel();
		downPan.setLayout(new BoxLayout(downPan, BoxLayout.X_AXIS));
		for (int i = startPotDown; i <= endPotDown; i++){
			myPotLabels[i] =  new PotLabel(i, ESeatPlayer.DOWN,0);
			downPan.add(myPotLabels[i]);
		}
		//
		JPanel simplePotPan = new JPanel();
		simplePotPan.setLayout(new BoxLayout(simplePotPan, BoxLayout.Y_AXIS));
		simplePotPan.add(upPan);
		simplePotPan.add(Box.createVerticalStrut(myHeightPot/2));
		simplePotPan.add(downPan);
		simplePotPan.setPreferredSize(new Dimension(myWidthPot* (countAllPots / 2 - 1),(int) (myHeightPot * 2.5)));
		
		//   
		myPotLabels[kalahUp] = new PotLabel(countPots, ESeatPlayer.UP, 0);
		JPanel manUpPan = new JPanel();
		manUpPan.setLayout(new BoxLayout(manUpPan, BoxLayout.X_AXIS));
		manUpPan.add(myPotLabels[kalahUp]);
			
		//  
		myPotLabels[kalahDown] = new PotLabel(countPots, ESeatPlayer.DOWN,0);
		JPanel manDownPan = new JPanel();
		manDownPan.setLayout(new BoxLayout(manDownPan, BoxLayout.Y_AXIS));
		manDownPan.add(myPotLabels[kalahDown]);		
		
		this.add(manUpPan);
		this.add(simplePotPan);
		this.add(manDownPan);
		
		//  Label' 
		for(int i = 0; i < myPotLabels.length; i++){
			myPotLabels[i].setConstSize(myHeightPot, myWidthPot);
			myPotLabels[i].addMouseListener(ml);
			myPotLabels[i].addMouseMotionListener(ml);
		}
		this.setPreferredSize(new Dimension(myWidthPot* (countAllPots / 2 + 1),(int) (myHeightPot * 2.5)));
		this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));		
	}
	
	public IGame getGame() {
		return myGame;
	}
	
	public void setGame(IGame game) {
		this.myGame = game;		
	}
	
	public IModelListener createModelListener(){
		return new ModelListener();
	}
	
	public IGameListener createGameListener(){
		return new GameListener();
	}
	
	//      
	private void setValueLabels(int [] stateBoard){
		for(int i = 0; i < myPotLabels.length; i++){
			myPotLabels[i].setCountBeans(stateBoard[i]);
		}
	}
	/**
	 *    ,    - 
	 *
	 */
	public  void callRepaint(){
		setValueLabels(myGame.getBoard().getState());
		repaint();
	}
	
	private class MouseListener extends MouseAdapter implements MouseMotionListener{
		
		public void mouseDragged(MouseEvent e) {}

		public void mouseMoved(MouseEvent e) {}

		public void mouseClicked(MouseEvent e) {
			Logger.getInctanse().println("Click");
			if (!myIsGameNow || myStopGame){
				return;
			}			
			if (myCountPlayers == 0){//  this  ,    Ckick 
				return;
			}
			LocalPlayer pl = null;
			if (myCountPlayers == 1 || myLocalPlayers[0].isCurent()){
				pl =  myLocalPlayers[0];
			}else if (myLocalPlayers[1].isCurent()){
				pl =  myLocalPlayers[1];
			}
			if (pl == null){//   -   (,      AI)
				return;
			}
			PotLabel potLabel = (PotLabel)e.getSource();
			if (potLabel.getSeat() != pl.getSeat()){
				return;
			}
			int k = potLabel.getNumberPot();
			if (myGame.canChoose(k)){
				pl.setPot(k);
				pl.setReady(true);
			}
		}		
	}
	
	class ModelListener implements IModelListener{
			
		public void statePotsChanged() {
			int stateBoard [] = myGame.getBoard().getState(); 
			setValueLabels(stateBoard);
			repaint();			
		}
		public void statePotChanged(int pot, int countBeans) {
			myPotLabels[pot].setCountBeans(countBeans);			
			repaint();			
		}
	}
	
	class GameListener extends AbstractGameListener{			

		public void win() {
			//   
			// 
			buttonPanel.actionsButton();
			// 
			if (myGame.isWin()){
				JOptionPane.showMessageDialog(
						BoardPanel.this, 
						myGame.getWiner().toString(),
						"", 
						JOptionPane.INFORMATION_MESSAGE,
						new ImageIcon(Main.class.getClassLoader().getResource("images/icon_daumenhoch.gif")));
				return;
			}			
		}		
	}
	
	public IPlayer getPlayer1(){
		return myLocalPlayers[0];
	}
	
	public IPlayer getPlayer2(){
		return myLocalPlayers[1];
	}	
	
/*	private class MyKeyListener implements KeyListener{

		public void keyPressed(KeyEvent key) {
			System.out.println("BordPanel Key");
			switch (key.getKeyCode()){
			case KeyEvent.VK_F1:
				createHelpWindow();
				break;
			case KeyEvent.VK_F3:
				createAboutWindow();
				break;
			}
		}
		public void keyReleased(KeyEvent e) {}
		public void keyTyped(KeyEvent e) {}		
	}
	
	private void createHelpWindow(){
		UIManager.put("OptionPane.yesButtonText", "OK (F1)");
		UIManager.put("OptionPane.noButtonText", " (F2)");
		UIManager.put("OptionPane.cancelButtonText", "  (F3)");
		JOptionPane.showMessageDialog(
				this, 
				new String[]{
						"Bantumi ",
						"\n",
						"\n"},
				"  Bantumi ",				
				JOptionPane.INFORMATION_MESSAGE);
		}
	
	private void createAboutWindow (){
		//     
		URL urlIconAbout = MainFrame.class.getClassLoader().getResource("images/iconAbout.jpg");
		JOptionPane.showMessageDialog(
				this,
				new String[]{"  -   ","Bantumi  v1.0"},
				" ",
				JOptionPane.INFORMATION_MESSAGE,
				new ImageIcon(urlIconAbout) );
	}
*/
}
