package org.amse.mARICa.view;

import java.awt.*;
import java.awt.event.*;
import java.net.URL;

import javax.swing.*;

import org.amse.mARICa.Logger;
import org.amse.mARICa.Main;
import org.amse.mARICa.game.*;
import org.amse.mARICa.model.*;
import org.amse.mARICa.model.impl.*;
import org.amse.mARICa.model.impl.players.AIAlphaBetaPlayer;
import org.amse.mARICa.model.impl.players.NetPlayer;
import org.amse.mARICa.view.wizard.WizardDialog;
/**
 *       /
 *    :
 * BoardPanel ,  , , ..  game.start();
 *    :
 *  ,  ,  BoardPanel
 * 
 * @author mARICa
 * 
 *
 */
public class ButtonPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	
	BoardPanel boardPanel;
	ArrowPanel arrowPanel;
	MainFrame mainFrame;
	public boolean isGameNow;//   MainFrame
	
	private JButton myButton;
	private JComboBox myComboBoxDown;
	private JComboBox myComboBoxUp;
	
	private ImageIcon myStartIcon;
	private ImageIcon myStopIcon;
	
	private IGame myGame;
	
	public ButtonPanel(){
		super();
		//this.setBorder(new LineBorder(Color.green, 3));
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		ClassLoader cl = Main.class.getClassLoader();
		myStartIcon = new ImageIcon(cl.getResource("images/start.png"));
		myStopIcon = new ImageIcon(cl.getResource("images/stop.png"));
		
		ImageIcon [] kindPl = new ImageIcon [3]; 
		kindPl[0] = new ImageIcon(cl.getResource("images/man.png"));
		kindPl[1] = new ImageIcon(cl.getResource("images/ai.png"));
		kindPl[2] = new ImageIcon(cl.getResource("images/net.png"));
		
		myComboBoxDown = new JComboBox(kindPl);
		myComboBoxUp = new JComboBox(kindPl);
		
		myButton = new JButton();
		myButton.setIcon(myStartIcon);
		myButton.addActionListener(new ActionListenerForButton());
		myButton.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		Dimension dim = new Dimension(myButton.getPreferredSize().width, myComboBoxUp.getPreferredSize().height);
		myComboBoxDown.setMaximumSize(dim);
		myComboBoxUp.setMaximumSize(dim);
		myButton.setMaximumSize(dim);
		
		this.add(Box.createVerticalStrut(10));
		this.add(myComboBoxUp);
		this.add(Box.createVerticalStrut(20));
		this.add(myButton);
		this.add(Box.createVerticalStrut(20));
		this.add(myComboBoxDown);
		this.add(Box.createVerticalStrut(10));
		
		this.addKeyListener(new MyKeyListener());
	}
	
	public void actionsButton(){
		//    ,    ,   
		myButton.getActionListeners()[0].actionPerformed(null);
	}
	
	private IPlayer createPlayer(boolean isDown, EKindPlayer ekind, IGame game, WizardDialog wd){
		IPlayer pl = null;
		if (ekind == EKindPlayer.HUMANLOC){ 
			pl = MainFrame.myBoardPanel.createLocalPlayer(ekind);			
		} if (ekind == EKindPlayer.COMP){
			if (isDown){
				pl = new AIAlphaBetaPlayer(ekind, game, wd.getLevelAIDown(), wd.isRandAIDown());
			}else{
				pl = new AIAlphaBetaPlayer(ekind, game, wd.getLevelAIUp(), wd.isRandAIUp());
			}
		} if (ekind == EKindPlayer.HUMANLAN){
			NetPlayer net = new NetPlayer(ekind, game, wd.isServer(), wd.getIP(), wd.getPort());
			net.setListenerStopGame(this);
			pl = net;	
		}
		return pl;
	}	
	
	public void reverseSeatPlayer(){
		int down = myComboBoxDown.getSelectedIndex();
		int up = myComboBoxUp.getSelectedIndex();
		myComboBoxDown.setSelectedIndex(up);
		myComboBoxUp.setSelectedIndex(down);
		myGame.reverseSeatPlayer();
		
	}
	/**
	 *     
	 *  ,        
	 */
	public void cancelGameOtherPlayer(){
		Logger.getInctanse().println("cancelGame");
		if (((ActionListenerForButton)myButton.getActionListeners()[0]).stateButton){
			myButton.getActionListeners()[0].actionPerformed(null);
		}
		JOptionPane.showMessageDialog(
				mainFrame, 
				"   ", 
				" ",
				JOptionPane.WARNING_MESSAGE,
				new ImageIcon(Main.class.getClassLoader().getResource("images/icon_cry.gif")) );
	}
	
	private class ActionListenerForButton implements ActionListener{
		
		boolean stateButton;//false - ""
		
		public void actionPerformed(ActionEvent e) {
			if (stateButton){//  ""
				Logger.getInctanse().println("press Stop");
				isGameNow = false;
				boardPanel.getGame().setIsGameNow(false);
				boardPanel.myIsGameNow = false;
				((Game)boardPanel.getGame()).callMessageListenersStopTime();
				boardPanel.setEnabled(false);
				
			}else{//  ""
				Logger.getInctanse().println("press Start");				
				EKindPlayer ekindDown, ekindUp;
				ekindDown = analyseComboBox(myComboBoxDown);
				ekindUp = analyseComboBox(myComboBoxUp);
								
				WizardDialog wd = new WizardDialog(mainFrame);
				if (ekindDown == EKindPlayer.COMP && ekindUp == EKindPlayer.COMP){
					wd.createAIDialog( 2, null);
				}else if (ekindDown == EKindPlayer.COMP){
					wd.createAIDialog(1, ESeatPlayer.DOWN);
				}else if (ekindUp == EKindPlayer.COMP){
					wd.createAIDialog(1, ESeatPlayer.UP);
				}				
				if (ekindDown == EKindPlayer.HUMANLAN && ekindUp == EKindPlayer.HUMANLAN){
					JOptionPane.showMessageDialog(
							mainFrame, 
							" 2   ", 
							"",
							JOptionPane.ERROR_MESSAGE,
							new ImageIcon(Main.class.getClassLoader().getResource("images/error.gif")) );
					return;
				}else if (ekindDown == EKindPlayer.HUMANLAN){
					wd.createNetDialog();
				}else if (ekindUp == EKindPlayer.HUMANLAN){
					wd.createNetDialog();
				}				
				wd.setSize(300, 250);
				int x = mainFrame.getLocation().x + (mainFrame.getWidth() / 2) - (wd.getWidth() / 2);
				int y = mainFrame.getLocation().y + (mainFrame.getHeight() / 2) - (wd.getHeight() / 2);
				wd.setLocation(x,y);
				wd.setVisible(true);				
				if (!wd.isOk()){
					return;
				}
				Settings.setCountBeans(wd.getCountBeans());
				Settings.setSpeedHand(wd.getSpeedHand());				
				
				//     BoardPanel				
				IBoard board = new Board(Settings.getCountPots(), Settings.getCountBeans());	
				myGame = new Game(board);
				boardPanel.beforeStartGame();
				boardPanel.setGame(myGame);
				         
				myGame.setPlayer1(createPlayer(true, ekindDown,myGame, wd));
				myGame.setPlayer2(createPlayer(false, ekindUp,myGame, wd));
				
				ConnectDialog con = null;
				if (myGame.getPlayer1().getKindPlayer() == EKindPlayer.HUMANLAN){
					con = new ConnectDialog(mainFrame,(NetPlayer)myGame.getPlayer1(), ButtonPanel.this);
				}else if (myGame.getPlayer2().getKindPlayer() == EKindPlayer.HUMANLAN){
					con = new ConnectDialog(mainFrame,(NetPlayer)myGame.getPlayer2(), ButtonPanel.this);										
				}
				if (con != null){
					con.setSize(250, 90);
					x = mainFrame.getLocation().x + (mainFrame.getWidth() / 2) - (con.getWidth() / 2);
					y = mainFrame.getLocation().y + (mainFrame.getHeight() / 2) - (con.getHeight() / 2);
					con.setLocation(x,y);					
					con.setVisible(true);
					while (!con.isReady()){
						try {
							Thread.sleep(1000);
						} catch (InterruptedException ee) {
							JOptionPane.showMessageDialog(
									mainFrame,   
									ee.getMessage(), 
									"",
									JOptionPane.ERROR_MESSAGE,
									new ImageIcon(Main.class.getClassLoader().getResource("images/error.gif")) );
						}
					}
					if (con.isError() ){
						return;
					}
				}				
				//   -  
				board.setCountBeans(Settings.getCountBeans());
				myGame.addListener(boardPanel.createGameListener());
				myGame.addListener(arrowPanel.createGameListener());
				myGame.addListener(boardPanel.getHand().createGameListener());
				myGame.addListener(new ShowExseption());
				
				//BoardPanel  
				boardPanel.getHand().setSpeed();
				boardPanel.getHand().setStartPos(boardPanel.getLocation());
				boardPanel.callRepaint();
				boardPanel.setEnabled(true);
				((Game)myGame).start();
				boardPanel.myIsGameNow = true;
				isGameNow = true;
			}
			//  
			stateButton = !stateButton;
			changeState();
		}

		private EKindPlayer analyseComboBox(JComboBox box) {
			switch (box.getSelectedIndex()){
			case 0: return EKindPlayer.HUMANLOC; 
			case 1: return EKindPlayer.COMP; 
			case 2: return EKindPlayer.HUMANLAN; 
			}
			return null;
		}
		
		private void changeState(){
			if (!stateButton){
				myButton.setIcon(myStartIcon);
			}else{
				myButton.setIcon(myStopIcon);
			}
		}		
	}
	
	private class ShowExseption extends AbstractGameListener{
		
		public void happenException(BantumiException e){
			/*if (isGameNow){
				Logger.getInctanse().println("isGameNow=" + isGameNow);
				actionsButton();
			}*/
			JOptionPane.showMessageDialog(
					mainFrame,   
					e.getMessage(), 
					"",
					JOptionPane.ERROR_MESSAGE,
					new ImageIcon(Main.class.getClassLoader().getResource("images/error.gif")) );
			if(Logger.getInctanse().isLog()){
				e.printStackTrace();
			}
		} 
	}
	
	private class MyKeyListener implements KeyListener{

		public void keyPressed(KeyEvent key) {
			Logger.getInctanse().println("ButtonPanel Key");
			switch (key.getKeyCode()){
			case KeyEvent.VK_F1:
				createHelpWindow();
				break;
			case KeyEvent.VK_F3:
				createAboutWindow();
				break;
			}
		}
		public void keyReleased(KeyEvent e) {}
		public void keyTyped(KeyEvent e) {
			Logger.getInctanse().println("ButtonPanel Key");
		}		
	}
	
	private void createHelpWindow(){
		UIManager.put("OptionPane.yesButtonText", "OK (F1)");
		UIManager.put("OptionPane.noButtonText", " (F2)");
		UIManager.put("OptionPane.cancelButtonText", "  (F3)");
		JOptionPane.showMessageDialog(
				mainFrame, 
				new String[]{
						"Bantumi ",
						"\n",
						"\n"},
				"  Bantumi ",				
				JOptionPane.INFORMATION_MESSAGE);
		}
	
		private void createAboutWindow (){
			//     
			URL urlIconAbout = MainFrame.class.getClassLoader().getResource("images/iconAbout.jpg");
			JOptionPane.showMessageDialog(
					mainFrame,
					new String[]{"  -   ","Bantumi  v1.0"},
					" ",
					JOptionPane.INFORMATION_MESSAGE,
					new ImageIcon(urlIconAbout) );
		}
}
