package org.amse.mARICa.view;

import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.*;

import org.amse.mARICa.Logger;
import org.amse.mARICa.Main;
import org.amse.mARICa.model.EBantumiException;
import org.amse.mARICa.model.impl.BantumiException;
import org.amse.mARICa.model.impl.Settings;
import org.amse.mARICa.model.impl.players.NetPlayer;

public class ConnectDialog extends JDialog {
	private NetPlayer myNP;	
	private ButtonPanel myButtonPanel;
	private boolean myError;
	private boolean myIsReady;
	private JFrame mainFrame;
	private static final long serialVersionUID = 1L;

	public ConnectDialog (JFrame parent,  NetPlayer player, ButtonPanel bp){
		super(parent, "");
		mainFrame = parent;
		//this.setResizable(false);
		this.setModal(true);
		this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);		
		this.addWindowListener(new WinAct());
		myNP = player;
		myButtonPanel = bp;
		String title = "   " + myNP.getPort();
		this.setTitle(title);
		ClassLoader cl = Main.class.getClassLoader();
		Icon icon = new ImageIcon(cl.getResource("images/connect.gif"));
		
		JPanel pan = new JPanel();
		pan.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		pan.setLayout(new BoxLayout(pan, BoxLayout.X_AXIS));
		JLabel label = new JLabel(icon);
		pan.add(label);
		this.setContentPane(pan);		
		
		Dimension dim = new Dimension(icon.getIconWidth()+10, icon.getIconHeight()+10);
		this.setMinimumSize(dim);
		this.setPreferredSize(dim);
		this.setMaximumSize(dim);
		
		createThread();		
	}
	
	private class WinAct extends WindowAdapter{
		public void windowClosing(WindowEvent e) {
			try {
				myNP.setStopGame(true);
			} catch (BantumiException e1) {
				//  ,   setStopGame  BantumiException
				if (Logger.getInctanse().isLog()){
					e1.printStackTrace();
				}
				myError = true;
				myIsReady = true;
				JOptionPane.showMessageDialog(
						mainFrame,   
						e1.getMessage(), 
						"",
						JOptionPane.ERROR_MESSAGE,
						new ImageIcon(Main.class.getClassLoader().getResource("images/error.gif")) );
			}
			ConnectDialog.this.dispose();			
		}
	}
	
	public boolean isError(){
		return myError;
	}
	
	public boolean isReady(){
		return myIsReady;
	}
	
	/*public void setVisible(boolean b){
		createThread();	
		super.setVisible(b);			
	}*/
	
	private void createThread(){
		Thread connectThread = new Thread("connect"){
			public void run(){
				try {
					myNP.init();	
					myIsReady = true;
				} catch (BantumiException e) {
					if (!(  e.getCode() == EBantumiException.COUNT_BEANS_WRONG || 
							e.getCode() == EBantumiException.SEAT_WRONG  || 
							e.getCode() == EBantumiException.COUNT_BEANS_SEAT_WRONG)){
						myError = true;
						myIsReady = true;
						JOptionPane.showMessageDialog(
								mainFrame,   
								e.getMessage(), 
								"",
								JOptionPane.ERROR_MESSAGE,
								new ImageIcon(Main.class.getClassLoader().getResource("images/error.gif")) );
					}else{
						boolean myAnswerYes = true;
						UIManager.put("OptionPane.noButtonText", "");
						UIManager.put("OptionPane.yesButtonText", "");
						ImageIcon icon = new ImageIcon(Main.class.getClassLoader().getResource("images/icon_mega_kaugummi.gif"));
						if (e.getCode() == EBantumiException.COUNT_BEANS_WRONG || e.getCode() == EBantumiException.COUNT_BEANS_SEAT_WRONG){
							String question = EBantumiException.COUNT_BEANS_WRONG.getStringValue() + "\n   " + myNP.getReceiveCountBeans() + "? (  -  )";
							int res = JOptionPane.showConfirmDialog(
									mainFrame,
									question,
									"",
									JOptionPane.YES_NO_OPTION,
									JOptionPane.WARNING_MESSAGE,
									icon);
							if (res == JOptionPane.YES_OPTION){
								Settings.setCountBeans(myNP.getReceiveCountBeans());
							}else {
								//	 .     
								myAnswerYes = false;
								myError = true;	
								myIsReady = true;
							}						
						}
						if (e.getCode() == EBantumiException.SEAT_WRONG || e.getCode() == EBantumiException.COUNT_BEANS_SEAT_WRONG){
							String question = EBantumiException.SEAT_WRONG.getStringValue() + "\n ? (  -  )";
							int res = JOptionPane.showConfirmDialog(
									mainFrame,
									question,
									"",
									JOptionPane.YES_NO_OPTION,
									JOptionPane.WARNING_MESSAGE,
									icon);
							if (res == JOptionPane.YES_OPTION){
								myButtonPanel.reverseSeatPlayer();
							}else {
								// .     
								myAnswerYes = false;
								myError = true;
								myIsReady = true;
							}						
						}
						if (myAnswerYes){
							myNP.sendAnswerYes();
						}else{
							myNP.sendAnswerNo();
						}
					}				
				}
				myIsReady = true;
				ConnectDialog.this.dispose();
			}
		};
		connectThread.start();
	}
	
	

}
