package org.amse.mARICa.view;


import java.awt.Dimension;
import javax.swing.*;

import org.amse.mARICa.Main;
import org.amse.mARICa.model.ESeatPlayer;
/**
 * Label    
 * static      
 *      
 *   (  )
 *      
 * @author mARICa
 *
 */
public class PotLabel extends JLabel {
	private static final long serialVersionUID = 1L;
	
	//  0..(countPots-1)
	private int myNumberPot;
	private ESeatPlayer mySeat;
	private int myCountBeans;	
	private static ImageIcon [] myPotIcons;
	
	{
		int countsPistures = 21;
		ClassLoader cl = Main.class.getClassLoader();
		myPotIcons = new ImageIcon[countsPistures];
		for(int i = 0; i < myPotIcons.length; i++){
			String name = "images/pots/pot" + i + ".png";
			myPotIcons[i] = new ImageIcon(cl.getResource(name));
		}
	}
	/**
	 *   () Label
	 *
	 */
	public PotLabel(){
		super();
		myCountBeans = -1;
	}

	public PotLabel(String name){
		super(name);
	}
	
	public PotLabel (int num, ESeatPlayer seat, int count){
		super();
		myNumberPot = num;	 
		mySeat = seat;
		setCountBeans(count);
	}
	 
	public int getNumberPot(){
		return myNumberPot;
	}
	
	public void setNumberPot(int num){
		myNumberPot = num;	
	}
	
	public void setConstSize(int height, int width){
		Dimension d = new Dimension(height, width); 
		this.setPreferredSize(d);
	}
	
	public ESeatPlayer getSeat(){
		return mySeat;
	}
	public int getCountBeans() {
		return myCountBeans;
	}
	public void setCountBeans(int countBeans) {
		myCountBeans = countBeans;
		if (myCountBeans >= myPotIcons.length){
			this.setIcon(myPotIcons[myPotIcons.length-1]);
		}else{
			this.setIcon(myPotIcons[myCountBeans]);
		}
		this.setToolTipText("" + myCountBeans);
	}	
}
