
package org.amse.mARICa.view.wizard;

import java.awt.Color;
import javax.swing.*;
import javax.swing.border.*;

import org.amse.mARICa.model.ESeatPlayer;

public class AIPanel extends JPanel {

	private static final long serialVersionUID = 1L;

	private JComboBox myComboDown;
	private JComboBox myComboUp;
	private JCheckBox myRandDown;
	private JCheckBox myRandUp;
	
	public AIPanel(int count, ESeatPlayer seat){
		this.setName("  ");
		init(count, seat);
	}
	/**
	 *  count  1,   seat -  
	 *  2,   null
	 * @param count
	 * @param seat
	 */
	public void init(int count, ESeatPlayer seat){
		
		String [] elements = {"1", "2", "3", "4", "5", "6", "7" };
		JPanel cp = this;
		//cp.setBorder(BorderFactory.createEmptyBorder(10, 5, 5, 10));
		cp.setLayout(new BoxLayout(cp,BoxLayout.Y_AXIS));
		
		if (count == 2 || (count == 1 && seat == ESeatPlayer.UP)){
			JPanel pan1 = createPanelUP(elements);
			cp.add(pan1);
			cp.add(Box.createVerticalGlue());
		}
		if (count == 2 || (count == 1 && seat == ESeatPlayer.DOWN)){
			JPanel pan2 = createPanelDOWN(elements);
			cp.add(pan2);
			cp.add(Box.createVerticalGlue());
		}			
	}
	
	private JPanel createPanelUP(String [] elements){
		JPanel pan = new JPanel();
		pan.setBorder(new TitledBorder(new LineBorder(Color.black,2)," "));
		pan.add(new JLabel(""));
		myComboUp = new JComboBox(elements);
		pan.add(myComboUp);
		myRandUp = new JCheckBox(" ", true);
		pan.add(myRandUp);		
		return pan;		
	}

	private JPanel createPanelDOWN(String [] elements){
		JPanel pan = new JPanel();
		pan.setBorder(new TitledBorder(new LineBorder(Color.black,2)," "));
		pan.add(new JLabel(""));
		myComboDown = new JComboBox(elements);
		pan.add(myComboDown);
		myRandDown = new JCheckBox(" ", true);
		pan.add(myRandDown);
		return pan;
	}	
	/**
	 * package local - WizardDialog 
	 */	
	int getLevelAIDown(){
		return Integer.valueOf((String)myComboDown.getSelectedItem());
	}
	/**
	 * package local - WizardDialog 
	 */
	int getLevelAIUp(){
		return Integer.valueOf((String)myComboUp.getSelectedItem());
	}
	/**
	 * package local - WizardDialog 
	 */
	boolean isRandAIDown(){
		return myRandDown.isSelected();
	}
	/**
	 * package local - WizardDialog 
	 */
	boolean isRandAIUp(){
		return myRandUp.isSelected();
	}

}

