package org.amse.mARICa.view.wizard;

import java.awt.Color;
import java.awt.Dimension;
import java.net.InetAddress;
import java.net.UnknownHostException;

import javax.swing.*;

public class NetPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	
	private JRadioButton myRadioServer;
	private JRadioButton myRadioClient;
	private JTextField myIPServer;
	private JTextField myIPClient;
	private JTextField myPortServer;
	private JTextField myPortClient;
	private boolean myIsServer;
	private final String s = " IP";
	
	public NetPanel(){
		this.setName("  ");
		
		//this.setPreferredSize(new Dimension(280, 200));
		init();
		
		JPanel cp =this;
		cp.setLayout(new BoxLayout(cp,BoxLayout.Y_AXIS));
		cp.add(Box.createVerticalGlue());
		
		cp.add(createPanel("  ", myRadioServer, s, myIPServer, myPortServer));
		cp.add(Box.createVerticalGlue());
		cp.add(createPanel("  ", myRadioClient,"    IP", myIPClient,myPortClient));
		cp.add(Box.createVerticalGlue());
		
		//cp.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		
		ButtonGroup bg = new ButtonGroup ();
		bg.add(myRadioServer);
		bg.add(myRadioClient);
		try {
			myIPServer.setText(InetAddress.getLocalHost().getHostAddress());
		} catch (UnknownHostException e) {
			myIPServer.setText("127.0.0.1");
		}
		myIPServer.setEnabled(false);	
	}
	
	private void init(){
		myRadioServer = new JRadioButton();
		myRadioClient = new JRadioButton();
		myIPServer = new JTextField(10);
		myIPClient = new JTextField(10);
		myPortServer = new JTextField(5);
		myPortClient = new JTextField(5);
		
		myIPServer.setToolTipText(" IP ");
		myIPClient.setToolTipText("IP    ,   ");
		myPortServer.setToolTipText("  0..65535");
		myPortClient.setToolTipText("  0..65535");
	}
	
	
	private void makeSameSize(JComponent c){
		Dimension dim = c.getPreferredSize();
		c.setMinimumSize(dim);
		c.setMaximumSize(dim);
	}
	
	private JPanel createPanel(String nameRad, JRadioButton radio, String nameLabel, JTextField ip, JTextField port){
		JPanel pan = new JPanel();
		pan.setBorder(BorderFactory.createLineBorder(Color.black, 2));
		pan.setLayout(new BoxLayout(pan, BoxLayout.Y_AXIS));
		
		radio.setText(nameRad);
		
		JPanel field = new JPanel();
		field.setLayout(new BoxLayout(field, BoxLayout.X_AXIS));
		field.add(Box.createHorizontalGlue());
		JLabel l = new JLabel(nameLabel);
		if (nameLabel == s){
			l.setEnabled(false);
		}
		field.add(l);
		field.add(Box.createHorizontalGlue());
		field.add(ip);
		field.add(Box.createHorizontalGlue());
		field.add(new JLabel(": "));
		field.add(Box.createHorizontalGlue());
		field.add(port);
		field.add(Box.createHorizontalGlue());
		
		makeSameSize(ip);
		makeSameSize(port);
		
		pan.add(radio);
		pan.add(field);
		radio.setAlignmentX(JComponent.LEFT_ALIGNMENT);
		field.setAlignmentX(JComponent.LEFT_ALIGNMENT);
		
		pan.setAlignmentX(JComponent.CENTER_ALIGNMENT);
		return pan;
	}	

	private void showOptionPane(String message){
		JOptionPane.showMessageDialog(
				this, 
				message, 
				"",
				JOptionPane.ERROR_MESSAGE);
	}
	
	public boolean actionOk(){
		if (!myRadioServer.isSelected() & !myRadioClient.isSelected()){
			showOptionPane("  ");
			return false;
		}
		if (myRadioClient.isSelected() && myIPClient.getText().equals("")){
			showOptionPane(" IP/hostname ");
			return false;
		}
		if (myRadioClient.isSelected() && myPortClient.getText().equals("")){
			showOptionPane("   ");
			return false;
		}
		if (myRadioServer.isSelected() && myPortServer.getText().equals("")){
			showOptionPane("   ");
			return false;
		}
		myIsServer = myRadioServer.isSelected();
		return true;
	}
	
	/**
	 * package local - WizardDialog 
	 */		
	String getIP() {
		return myIPClient.getText();
	}
	/**
	 * package local - WizardDialog 
	 */
	int getPort() {
		int port;
		try{
			if (myIsServer){
				port = Integer.valueOf(myPortServer.getText());
			}else{
				port = Integer.valueOf(myPortClient.getText());
			}
			if (port > 65535){
				return 65535;
			}
			return port;
		}catch (NumberFormatException e){
			return 65000;
		}
	}
	/**
	 * package local - WizardDialog 
	 */
	boolean isServer() {
		return myIsServer;
	}
}

