package org.amse.mARICa.view.wizard;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.amse.mARICa.Main;
import org.amse.mARICa.model.impl.Settings;

public class SettingsPanel extends JPanel{

	private static final long serialVersionUID = 1L;
	
	private JComboBox myComboCount;
	private JLabel myPot;
	private JSlider mySpeed;
	private JLabel myHandLabel;
	private ImageIcon [] myIconsPot;
	private int millis;
	
	public SettingsPanel (){
		this.setName(" ");		
		millis = Settings.getSpeedHand();
		ClassLoader cl = Main.class.getClassLoader();
		myIconsPot = new ImageIcon[6];
		for(int i = 1; i <= myIconsPot.length; i++){
			String name = "images/pots/pot" + i + ".png";
			myIconsPot[i-1] = new ImageIcon(cl.getResource(name));
		}
		ImageIcon icon = new ImageIcon(cl.getResource("images/hand/palmup.png"));
		myHandLabel = new JLabel(icon);
		
		//this.setPreferredSize(new Dimension(280, 200));		
		
		JPanel cp = this;
		cp.setLayout(new BoxLayout(cp,BoxLayout.Y_AXIS));
		
		cp.add(Box.createVerticalGlue());		
		cp.add(createPanelCount());
		cp.add(Box.createVerticalGlue());
		cp.add(createPanelSpeed());
		cp.add(Box.createVerticalGlue());
		
		//cp.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));	
	}
	
	private JPanel createPanelCount(){
		Integer [] elements = new Integer []{1,2,3,4,5,6};
		JPanel pan = new JPanel();
		pan.setLayout(new BoxLayout(pan,BoxLayout.X_AXIS ));
		pan.setBorder(new TitledBorder(new LineBorder(Color.black,2),"   "));
		myComboCount = new JComboBox(elements);
		myComboCount.setSelectedIndex(Settings.getCountBeans()-1);
		myPot = new JLabel(myIconsPot[Settings.getCountBeans()-1]);
		myComboCount.setMaximumSize(myComboCount.getPreferredSize());
		myComboCount.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				myPot.setIcon(myIconsPot[myComboCount.getSelectedIndex()]);				
			}
			
		});
		
		pan.add(Box.createHorizontalGlue());
		pan.add(myComboCount);
		pan.add(Box.createHorizontalGlue());
		pan.add(myPot);
		pan.add(Box.createHorizontalGlue());
		return pan;		
	}

	private JPanel createPanelSpeed(){
		JPanel pan = new JPanel();
		pan.setLayout(new BoxLayout(pan,BoxLayout.Y_AXIS ));
		pan.setBorder(new TitledBorder(new LineBorder(Color.black,2),"  "));
		mySpeed = new JSlider(1,5, Settings.getSpeedHand());
		mySpeed.setPaintLabels(true);
		mySpeed.setMajorTickSpacing(1);
		mySpeed.setPaintTicks(true);
		mySpeed.addChangeListener(new ChangeListener(){

			public void stateChanged(ChangeEvent e) {
				millis = ((JSlider)e.getSource()).getValue();				
			}
			
		});
		pan.add(Box.createVerticalGlue());
		pan.add(mySpeed);
		pan.add(Box.createVerticalGlue());
		return pan;
	}	
	
	public void movingHandLabel() {
		int min = mySpeed.getLocation().x;
		int max = mySpeed.getSize().width + min;
		int y = myHandLabel.getLocation().y;
		int offset = 10;
		int k = 1;
		while(true){
			while(myHandLabel.getLocation().x > min && myHandLabel.getLocation().x < max){
				myHandLabel.setLocation(myHandLabel.getLocation().x + k*offset, y);
				try {
					Thread.sleep(millis * 50);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			k *= -1;
		}
	}
	
	
	/**
	 * package local - WizardDialog 
	 */
	int getCountBeans(){
		return myComboCount.getSelectedIndex()+1;
	}
	/**
	 * package local - WizardDialog 
	 */
	int getSpeedHand(){
		return millis;
	}

}

