package org.amse.mARICa.view.wizard;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import org.amse.mARICa.model.ESeatPlayer;

public class WizardDialog extends JDialog{
	private static final long serialVersionUID = 1L;
	
	private JPanel [] myPanels;
	private int myCountDialogs;
	private int myCurrent;
	private JButton myBack;
	private JButton myCansel;
	private JButton myOk;	
	private JPanel myMainPanel;
	private JPanel myButtonPanel;
	private SettingsPanel mySetP;
	private AIPanel myAIP;
	private NetPanel myNetP;
	private boolean myIsOk;
	private JFrame myParent;
	
	public WizardDialog(JFrame parent){
		super(parent,"wizard");
		myParent = parent;
		myIsOk = true;
		myPanels = new JPanel [3];
		mySetP = new SettingsPanel();
		myPanels[myCountDialogs] = mySetP;
		myCountDialogs++;	
		myButtonPanel = createButtons();	
		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));	
		
		myCurrent = 1;
		createContent();	
		this.setModal(true);
		//this.setResizable(false);
		this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);		
	}	
	
	public void setLocationOnCentre(){
		int x = myParent.getLocation().x + (myParent.getWidth() / 2) - (this.getWidth() / 2);
		int y = myParent.getLocation().y + (myParent.getHeight() / 2) - (this.getHeight() / 2);
		setLocation(x,y);
	}
	public void createAIDialog( int count, ESeatPlayer seat){
		myAIP = new AIPanel(count, seat);
		myPanels[myCountDialogs] = myAIP;
		myCountDialogs++;
		changeNameButtons();
	}
	
	public void createNetDialog(){
		myNetP = new NetPanel();
		myPanels[myCountDialogs] = myNetP;
		myCountDialogs++;
		changeNameButtons();
	}
	
	private void createContent(){
		if(myMainPanel!=null)
				myMainPanel.setVisible(false);
		myMainPanel = myPanels[myCurrent-1];
		myMainPanel.setVisible(true);
		Container pan = getContentPane();
		pan.removeAll();
		pan.add(myMainPanel);
		pan.add(myButtonPanel);
		changeNameButtons();		
		this.setTitle(myPanels[myCurrent-1].getName());		
	}		
	
	private JPanel createButtons(){
		myBack = new JButton (" ");
		myCansel = new JButton ("");
		myOk = new JButton ("    ");
		createActions();
		JPanel myButtonPanel = new JPanel();
		myButtonPanel.setLayout(new BoxLayout(myButtonPanel, BoxLayout.X_AXIS));
		myButtonPanel.add(Box.createHorizontalStrut(10));
		myButtonPanel.add(myBack);
		myButtonPanel.add(Box.createHorizontalGlue());
		myButtonPanel.add(myCansel);
		myButtonPanel.add(Box.createHorizontalGlue());
		myButtonPanel.add(myOk);
		myButtonPanel.add(Box.createHorizontalStrut(10));
		return myButtonPanel;
	}
	
	private void changeNameButtons(){
		if (myCountDialogs == 1 && myCurrent == 1){
			myBack.setEnabled(false);
			myCansel.setText("");
			myOk.setText("    ");
			return;
		}
		if ( (myCountDialogs == 2 || myCountDialogs == 3) && myCurrent == 1){
			myBack.setEnabled(false);
			myCansel.setText("");
			myOk.setText(" ");
			return;
		}
		if ((myCountDialogs == 2 && myCurrent == 2) || (myCountDialogs == 3 && myCurrent == 3) ){
			myBack.setEnabled(true);
			myCansel.setText("");
			myOk.setText("    ");
			return;
		}
		if ( myCountDialogs == 3 && myCurrent == 2){
			myBack.setEnabled(true);
			myCansel.setText("");
			myOk.setText(" ");
			return;
		}
	}
	
	private void createActions(){
		myBack.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				myCurrent--;
				createContent();
				WizardDialog.this.repaint();
			}
			
		});	
		
		myOk.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				if (myPanels[myCurrent-1] instanceof NetPanel){
					if ( !((NetPanel)myPanels[myCurrent-1]).actionOk()){
						return;
					}
				}
				myCurrent++;
				if (myCurrent <= myCountDialogs){
					createContent();
				}else{
					WizardDialog.this.dispose();
				}
				WizardDialog.this.repaint();				
			}			
		});
		
		myCansel.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				WizardDialog.this.dispose();	
				myIsOk = false;
			}			
		});
		
		this.addWindowListener(new WinAct());
	}
	
	private class WinAct extends WindowAdapter{
		public void windowClosing(WindowEvent e) {
			WizardDialog.this.dispose();	
			myIsOk = false;
		}
	}
	
	public boolean isOk(){
		return myIsOk;
	}
	
	public int getCountBeans(){
		return mySetP.getCountBeans();
	}

	public int getSpeedHand(){
		return mySetP.getSpeedHand();
	}
	
	public int getLevelAIDown(){
		return myAIP.getLevelAIDown();
	}
	
	public int getLevelAIUp(){
		return myAIP.getLevelAIUp();
	}
	
	public boolean isRandAIDown(){
		return myAIP.isRandAIDown();
	}
	
	public boolean isRandAIUp(){
		return myAIP.isRandAIUp();
	}
	
	public String getIP() {
		return myNetP.getIP(); 
	}

	public int getPort() {
		return myNetP.getPort();	
	}

	public boolean isServer() {
		return myNetP.isServer();
	}

}
